edu.wpi.first.wpilibj

## Class DigitalSource

- java.lang.Object
- - edu.wpi.first.wpilibj.SensorBase
  - - edu.wpi.first.wpilibj.InterruptableSensorBase
    - - edu.wpi.first.wpilibj.DigitalSource

- Direct Known Subclasses:
    AnalogTriggerOutput, DigitalInput, DigitalOutput

      public abstract class DigitalSource
      extends InterruptableSensorBase

  DigitalSource Interface. The DigitalSource represents all the possible inputs for a counter or a quadrature encoder. The source may be either a digital input or an analog input. If the caller just provides a channel, then a digital input will be constructed and freed when finished for the source. The source can either be a digital input or analog trigger but not both.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class edu.wpi.first.wpilibj.InterruptableSensorBase

      `InterruptableSensorBase.WaitResult`

  - ### Field Summary

    - ### Fields inherited from class edu.wpi.first.wpilibj.InterruptableSensorBase

      `m_interrupt, m_isSynchronousInterrupt`

    - ### Fields inherited from class edu.wpi.first.wpilibj.SensorBase

      `kAnalogInputChannels, kAnalogOutputChannels, kDigitalChannels, kPCMModules, kPDPChannels, kPDPModules, kPwmChannels, kRelayChannels, kSolenoidChannels, kSystemClockTicksPerMicrosecond`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `DigitalSource()`

  - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `abstract int` | `getChannel()`
    `abstract boolean` | `isAnalogTrigger()`

    - ### Methods inherited from class edu.wpi.first.wpilibj.InterruptableSensorBase

      `allocateInterrupts, cancelInterrupts, disableInterrupts, enableInterrupts, getAnalogTriggerTypeForRouting, getPortHandleForRouting, readFallingTimestamp, readRisingTimestamp, requestInterrupts, requestInterrupts, setUpSourceEdge, waitForInterrupt, waitForInterrupt`

    - ### Methods inherited from class edu.wpi.first.wpilibj.SensorBase

      `checkAnalogInputChannel, checkAnalogOutputChannel, checkDigitalChannel, checkPDPChannel, checkPDPModule, checkPWMChannel, checkRelayChannel, checkSolenoidChannel, checkSolenoidModule, free, getDefaultSolenoidModule, setDefaultSolenoidModule`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### DigitalSource

          public DigitalSource()

  - ### Method Detail

    - #### isAnalogTrigger

          public abstract boolean isAnalogTrigger()

    - #### getChannel

          public abstract int getChannel()